summaryrefslogtreecommitdiffstats
path: root/tests
diff options
context:
space:
mode:
authorP. J. McDermott <pj@pehjota.net>2014-08-30 01:24:36 (EDT)
committer P. J. McDermott <pj@pehjota.net>2014-08-30 01:24:36 (EDT)
commit50ab260b801b266f94ef0ed6c555e128158dc240 (patch)
treee12ac47e7ebf49bf74badf7cb7a8192d1f601f98 /tests
parent79d6a73fec60b083e86d951fab7ebe9ef1f82595 (diff)
tests/arch_is_concerned.sh: New test
Diffstat (limited to 'tests')
-rwxr-xr-xtests/arch_is_concerned.sh98
-rw-r--r--tests/local.mk3
2 files changed, 100 insertions, 1 deletions
diff --git a/tests/arch_is_concerned.sh b/tests/arch_is_concerned.sh
new file mode 100755
index 0000000..64c07cc
--- /dev/null
+++ b/tests/arch_is_concerned.sh
@@ -0,0 +1,98 @@
+#!/bin/sh
+#
+# arch_is_concerned() tests
+#
+# Copyright (C) 2014 Patrick "P. J." McDermott
+#
+# This file is part of the ProteanOS Development Kit.
+#
+# The ProteanOS Development Kit is free software: you can redistribute
+# it and/or modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation, either version 3 of the
+# License, or (at your option) any later version.
+#
+# The ProteanOS Development Kit is distributed in the hope that it
+# will be useful, but WITHOUT ANY WARRANTY; without even the implied
+# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+# See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with the ProteanOS Development Kit. If not, see
+# <http://www.gnu.org/licenses/>.
+
+. "${srcdir}/tests/common.sh"
+
+use archplat
+
+do_test()
+{
+ local host_arch="${1}"
+ local arches="${2}"
+ local result="${3}"
+
+ if arch_is_concerned "${host_arch}" "${arches}"; then
+ if ! ${result}; then
+ printf 'False positive:\n' >&2
+ printf ' Host architecture: "%s"\n' \
+ "${host_arch}" >&2
+ printf ' Package architectures: "%s"\n' "${arches}" >&2
+ tests_es=1
+ fi
+ else
+ if ${result}; then
+ printf 'False negative:\n' >&2
+ printf ' Host architecture: "%s"\n' \
+ "${host_arch}" >&2
+ printf ' Package architectures: "%s"\n' "${arches}" >&2
+ tests_es=1
+ fi
+ fi
+}
+
+# Architecture: all
+
+do_test 'amd64-linux-glibc' 'all' false
+
+do_test 'i686-linux-glibc' 'all' false
+
+do_test 'all' 'all' true
+
+# Architecture: any
+
+do_test 'amd64-linux-glibc' 'any' true
+
+do_test 'i686-linux-glibc' 'any' true
+
+do_test 'all' 'any' false
+
+# Architecture: amd64-linux-glibc
+
+do_test 'amd64-linux-glibc' 'amd64-linux-glibc' true
+
+do_test 'i686-linux-glibc' 'amd64-linux-glibc' false
+
+do_test 'all' 'amd64-linux-glibc' false
+
+# Architecture: !amd64-linux-glibc
+
+do_test 'amd64-linux-glibc' '!amd64-linux-glibc' false
+
+do_test 'i686-linux-glibc' '!amd64-linux-glibc' true
+
+do_test 'all' '!amd64-linux-glibc' false
+
+# Architecture: amd64-linux-glibc cortexa8-linux-glibc
+
+do_test 'amd64-linux-glibc' 'amd64-linux-glibc cortexa8-linux-glibc' true
+
+do_test 'i686-linux-glibc' 'amd64-linux-glibc cortexa8-linux-glibc' false
+
+do_test 'all' 'amd64-linux-glibc cortexa8-linux-glibc' false
+
+# Architecture: amd64-linux-glibc all
+
+do_test 'amd64-linux-glibc' 'amd64-linux-glibc all' true
+
+do_test 'i686-linux-glibc' 'amd64-linux-glibc all' false
+
+do_test 'all' 'amd64-linux-glibc all' true
diff --git a/tests/local.mk b/tests/local.mk
index 8331753..ee57f01 100644
--- a/tests/local.mk
+++ b/tests/local.mk
@@ -2,4 +2,5 @@ TESTS = \
tests/parse_control.basic.sh \
tests/resolve_deps.basic.sh \
tests/match_arch.sh \
- tests/match_plat.sh
+ tests/match_plat.sh \
+ tests/arch_is_concerned.sh